diff -Naur nginx-1.1.14.orig/src/http/ngx_http_upstream.c nginx-1.1.14.patched/src/http/ngx_http_upstream.c
--- nginx-1.1.14.orig/src/http/ngx_http_upstream.c	2012-01-18 07:07:43.000000000 -0800
+++ nginx-1.1.14.patched/src/http/ngx_http_upstream.c	2012-01-31 15:25:01.000000000 -0800
@@ -3603,14 +3603,12 @@
             return NGX_OK;
         }
 
-        if (rc == NGX_OK) {
-            r->headers_out.location = ho;
-
-            ngx_log_debug1(NGX_LOG_DEBUG_HTTP, r->connection->log, 0,
-                           "rewritten location: \"%V\"", &ho->value);
+        if (rc != NGX_OK) {
+            return rc;
         }
 
-        return rc;
+        ngx_log_debug1(NGX_LOG_DEBUG_HTTP, r->connection->log, 0,
+                       "rewritten location: \"%V\"", &ho->value);
     }
 
     if (ho->value.data[0] != '/') {